"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isValidDataEncoding = exports.isDataEncoding = void 0;
function isDataEncoding(dataEncoding) {
    return !!dataEncoding && typeof dataEncoding === "object" && typeof dataEncoding.name === "string";
}
exports.isDataEncoding = isDataEncoding;
const validEncoding = ["DefaultBinary", "DefaultXml", "DefaultJson"];
function isValidDataEncoding(dataEncoding) {
    if (!dataEncoding) {
        return true;
    }
    if (Object.prototype.hasOwnProperty.call(dataEncoding, "name")) {
        dataEncoding = dataEncoding.name;
    }
    if (!dataEncoding) {
        return true;
    }
    return validEncoding.indexOf(dataEncoding) !== -1;
}
exports.isValidDataEncoding = isValidDataEncoding;
//# sourceMappingURL=data_encoding.js.map